<?php
// EMAIL DELIVERY 
//
// Copyright (c) 2010 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: email-delivery.inc.php 901 2012-08-30 15:23:13Z swilkerson $

include_once(dirname(__FILE__).'/../configwizardhelper.inc.php');


/**************************************
 * This part is common to all wizards *
 **************************************/
define('email_delivery_configwizard_data',serialize(array('get_stage1_html'=>1,
'validate_stage1_data'=>2,
'get_stage2_html'=>3,
'validate_stage2_data'=>4,
'get_stage3_opts'=>5,
'get_stage3_html'=>6,
'validate_stage3_data'=>7,
'get_stage4_opts'=>8,
'get_final_stage_html'=>9)));

class email_delivery_configwizard_textbox {
        /* I pray in the future these string contants can be replaced with 
	     PHP Opening and Closing Tags :) */
	const textboxf='	<tr>
	<td valign="top">
	<label>%s:</label><br class="nobr" />
	</td>
	<td>
<input type="%s" size="%s" name="%s" id="%s" value="%s" class="textfield"%s/><br class="nobr" />
	%s<br><br>
	</td>

	</tr>';
	const hiddenf='<input type="hidden" name="%s" value="%s">';

	var $label='An option';
	var $type='text';
	var $size=30;
	var $name='option';
	var $value='';
	var $extopts='';
	var $desc='Fill this in to set your option.';
	var $output;
	var $gomode=-1;

	function __construct($label, $type, $size, $name, $value, $extopts,
				$desc, $gomode) {
		if($label!='') $this->label=$label;
		if($type!='') $this->type=$type;
		if($size!='') $this->size=$size;
		if($name!='') $this->name=$name;
		if($value!='') $this->value=$value;
		if($extopts!='') $this->extopts=$extopts;
		if($desc!='') $this->desc=$desc;
		if($gomode!='') $this->gomode=$gomode;
		}

	public function parseinargs($inargs) {
		$this->value=grab_array_var($inargs,$this->name,$this->value);
		}

	const undeff = 'No %s specified.';
	const invalf = 'Invalid %s.';
	public function validate(&$errmsg,$mode) {
		if($errmsg!=''||$errmsg===array()) $this->output=&$output;
		$b=unserialize(email_delivery_configwizard_data);

		if($b[$mode]>$b[$this->gomode]) {
			if(have_value($this->value)==false)
				$errmsg[]=sprintf(self::undeff,htmlentities($this->label));
			else if($this->name==='hostname' &&
						is_valid_host_name($this->value)===false ||
					$this->name==='servicedesc' &&
						is_valid_service_name($this->value)===false)
				$errmsg[]=sprintf(self::invalf,htmlentities($this->label));
			}
		}

	public function html(&$output,$mode){

		$output.=$mode===$this->gomode?
				sprintf(self::textboxf,
			htmlentities($this->label),htmlentities($this->type),
			htmlentities($this->size),htmlentities($this->name),
			htmlentities($this->label),htmlentities($this->value),
			$this->extopts,htmlentities($this->desc)):
				sprintf(self::hiddenf,
			htmlentities($this->name),htmlentities($this->value));
		}

	public function objs(&$meta_arr,&$objt){
				$objt[check_command].='!'.$this->value;
				$meta_arr[$this->name]=$this->value;
		}
	}

class email_delivery_configwizard_trnstext extends email_delivery_configwizard_textbox {

	public function objs(&$meta_arr,&$objt){
				$meta_arr[$this->name]=$this->value;
		}
	}

class email_delivery_configwizard_checkbox {
	const chk='checked ';
	const textboxf='	<tr>
	<td valign="top">
	<label>%s:</label><br class="nobr" />
	</td>
	<td>
<input type="checkbox" name="%s" id="%s" %sclass="checkfield"%s/><br class="nobr" />
	%s<br><br>
	</td>

	</tr>';
	const hiddenf='<input type="hidden" name="%s" value="%s">';

	var $label='An option';
	var $name='option';
	var $value=FALSE;
	var $extopts='';
	var $desc='Fill this in to set your option.';
	var $output;
	var $mode=-1;
	var $gomode=-1;

	function __construct($label, $name, $value, $extopts, $desc, $gomode) {
		if($label!='') $this->label=$label;
		if($name!='') $this->name=$name;
		if($value!='') $this->value=$value;
		if($extopts!='') $this->extopts=$extopts;
		if($desc!='') $this->desc=$desc;
		if($gomode!='') $this->gomode=$gomode;
		}

	public function parseinargs($inargs) {
		$this->value=array_key_exists($this->name,$inargs);
		}

	public function validate(&$errmsg,$mode) {
		}

	public function html(&$output,$mode){
		if($output!=''||$output==='') $this->output=&$output;
		if($mode!='') $this->mode=$mode;

		$output.=($this->mode===$this->gomode)?(
				sprintf(self::textboxf,
			htmlentities($this->label),htmlentities($this->name),
			htmlentities($this->label),(($this->value)?(self::chk):''),$this->extopts,
			htmlentities($this->desc))):(($this->value)?(sprintf(self::hiddenf,
			htmlentities($this->name),1)):(''));
		}

	public function objs(&$meta_arr,&$objt){
				$objt[check_command].='!'.$this->value;
				$meta_arr[$this->name]=$this->value;
		}
	}

class email_delivery_configwizard_trnschk extends email_delivery_configwizard_checkbox {

	public function objs(&$meta_arr,&$objt){
				$meta_arr[$this->name]=$this->value;
		}
	}

class email_delivery_configwizard_stopstart_table {
	const tablbrkf='

	</table>


	<div class="sectionTitle">%s</div>


	<table>

';

	var $label='Section Title';
	var $name='unused-html-tag-name';
	var $mode=-1;
	var $gomode=-1;

	function __construct($label, $gomode) {
		if($label!='') $this->label=$label;
		if($gomode!='') $this->gomode=$gomode;
		}

	public function parseinargs($inargs) {
		}

	public function validate(&$errmsg,$mode) {
		}

	public function html(&$output,$mode){
		if($output!=''||$output==='') $this->output=&$output;
		if($mode!='') $this->mode=$mode;

		$output.=$this->mode===$this->gomode?
				sprintf(self::tablbrkf,htmlentities($this->label)):'';
		}

	public function objs(&$meta_arr,&$objt){
		}
	}
/**************************************************
 * The above ~200 lines are common to all wizards *
 **************************************************/

class email_delivery_object_configwizard {

	const name = 'email-delivery';
	const type = CONFIGWIZARD_TYPE_MONITORING;
	const description = 'Test mail server&lsquo;s reception and simulated user&lsquo;s inspection of email messages.';
	const displaytitle = 'Email Delivery';
//	const mainfunction = 'email_delivery__configwizard_func';
	const previewimage = 'email-delivery.png';

	public $mode='';
	public $inargs=null;
	public $outargs;
	public $result;
	public $args;

	var $textboxes=array();

	public function configwizard_init(){

		$this->args=array(
			CONFIGWIZARD_NAME => self::name,
            CONFIGWIZARD_VERSION => "1.1",
			CONFIGWIZARD_TYPE => self::type,
			CONFIGWIZARD_DESCRIPTION => self::description,
			CONFIGWIZARD_DISPLAYTITLE => self::displaytitle,
			CONFIGWIZARD_FUNCTION => CONFIGWIZARD_API_VERSION <= 2 ?
				'email_delivery_static_configwizard_func' :
				'email_delivery_static_configwizard::configwizard_func',
			CONFIGWIZARD_PREVIEWIMAGE => self::previewimage,
			);

		$this->textboxes=array(
			new email_delivery_configwizard_trnstext('Main Address','text','30',
'address','','','The IP address or FQDNS name of the Nagios Core resource for this check.',CONFIGWIZARD_MODE_GETSTAGE1HTML),
			new email_delivery_configwizard_trnstext(
'Host Name','text','20','hostname','','',
'The Host Name in Nagios Core.',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_trnstext(
'Service Description','text','20','servicedesc','Email Delivery','',
'The Description you\'d like to have associated with this test case.',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_stopstart_table('Email Details',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_textbox('To Address','text','20',
'smtpto','','','The email address to send the test message to.  This is used in the envelope headers and must match the IMAP account you wish to check.',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_textbox('From Address','text','20',
'smtpfrom','','','Address to use as the from/sender address in the envelope headers.',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_stopstart_table('SMTP Details',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_textbox('SMTP Address','text','30',
'smtpaddres','','','The IP address or FQDNS name of the SMTP server.',
CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_textbox('SMTP Username','text','20',
'smtpun','','','The username used to login to the SMTP server.',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_textbox('SMTP Password','password','20',
'smtppw','','','The password used to login to the SMTP server.',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_textbox('SMTP Port','text','6',
'smtpport','25','','Service port on the SMTP server.',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_checkbox(
'SMTP TLS','smtptls',FALSE,'',
'Use this to enable or disable TLS/AUTH for the SMTP plugin.',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_stopstart_table('IMAP Details',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_textbox('IMAP Address','text','30',
'imapaddres','','','The IP address or FQDNS name of the IMAP server.',
CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_textbox('IMAP Username','text','20',
'imapun','','','The username used to login to the IMAP server.',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_textbox('IMAP Password','password','20',
'imappw','','','The password used to login to the IMAP server.',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_textbox('IMAP Port','text','6',
'imapport','143','','Service port on the IMAP server.',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_checkbox(
'IMAP SSL','imapssl',FALSE,'',
'Use this to enable or disable SSL for the IMAP plugin.',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
/*			new email_delivery_configwizard_stopstart_table('Service Details',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_textbox('Paws4Login','text','3','opt_s','',
'The timeout value used during login, also used as a all through<br>'.
'for the MOTD and prompt.',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_textbox('Paws4Commands','text','3','opt_r',
'','Timeout used as a fall through for command output.',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_textbox('Commands','text','20','opt_d',
'','The commands to send separated by \';\'s.',
				CONFIGWIZARD_MODE_GETSTAGE2HTML),
			new email_delivery_configwizard_textbox('LoginMatch','text','20','opt_e',
'','A string to match typically from the MOTD.  The stopwatch starts at first SYN and ends after the Paws4Login timeout and a match on this string',
				CONFIGWIZARD_MODE_GETSTAGE2HTML), */
			);

		}

	private function check_installation(){
		$install_file=dirname(__FILE__).'/installed';
		//echo "INSTALL FILE: $install_file<BR>";
		if(file_exists($install_file)){
			//echo "INSTALLED!<BR>";
			return true;
			}
		//echo "NOT INSTALLED...<BR>";
		return false;
		}

	private function parseinargs() {
		// get variables that were passed to us
		foreach ($this->textboxes as $textbox) {
			$textbox->parseinargs($this->inargs);
			}

		if ($this->textboxes[1]->value=='') {
			$ha=@gethostbyaddr($this->textboxes[0]->value);
			$this->textboxes[1]->value = $ha=='' ?
				$this->textboxes[0]->value : $ha;
			}
		if ($this->textboxes[4]->value=='') 
			$this->textboxes[4]->value =
				$this->textboxes[0]->value;
		}

	function getstaget1html(&$output){

		$this->parseinargs();

		$output='';

		if(false){
			$output.='
			<div class="sectionTitle">Installation Required</div>
			
			<div style="color: red;"><b>NOTE:</b> This configuration wizard requires some additional software components to be installed on your Nagios XI system before it can be used.  The wizard has detected that you have not yet completed the necessary installation steps.  Follow the steps below to install the required components before proceeding:</div>
			<p>
			<ol>
			<li>Login to your Nagios XI server as the root user
			<li>Complete the installation by executing the following commands:
			</ol>
			</p>
<pre>
cd '.dirname(__FILE__).'/scripts
( . ./install.sh; )
</pre>
<br>
			';
			}
		else{
		
		$output.='

	<div class="sectionTitle">Email Server</div>


	<table>

';
		foreach ( $this->textboxes as $textbox ) {
				$textbox->html($output,$this->mode);
			}
		$output.='

	</table>

';
			}
		}

	function validatestage1data(&$output){
		$this->parseinargs();

		// check for errors
		$errmsg=array();
		if(false){
			$errmsg[]='Required components are not installed.';
			}
		else{
			if(have_value($this->textboxes[0]->value)==false)
				$errmsg[]='No address specified.';
			}

		foreach ($this->textboxes as $textbox) {
			$textbox->validate($errmsg,$this->mode);
			}

		if(count($errmsg)>0){
			$this->outargs[CONFIGWIZARD_ERROR_MESSAGES]=$errmsg;
			$this->result=1;
			}

		}

	function getstaget2html(&$output){
		$this->parseinargs();

		$output='

	<div class="sectionTitle">Email Server</div>


	<table>
';
		foreach ( $this->textboxes as $textbox ) {
			$textbox->html($output,$this->mode);
			}

		$output.='

	</table>


';
		}

	function validatestage2data(&$output) {
		$this->parseinargs();

		// check for errors
		$errmsg=array();

		foreach ($this->textboxes as $textbox) {
			$textbox->validate($errmsg,$this->mode);
			}

		if(count($errmsg)>0){
			$this->outargs[CONFIGWIZARD_ERROR_MESSAGES]=$errmsg;
			$this->result=1;
			}

		}

	function getstaget3html(&$output){
		$this->parseinargs();
		$output='

	<div class="sectionTitle">Email Delivery Options</div>


	<table>
';
		foreach ( $this->textboxes as $textbox ) {
				$textbox->html($output,$this->mode);
			}
		$output.='

	</table>


';

		}

	function validatestage3data(&$output) {

		}

	function getfinalstagehtml(&$output){

		}

	function getobjects() {
		$this->parseinargs();

		/*
		echo "SERVICES<BR>";
		print_r($services);
		echo "<BR>";
		echo "SERVICEARGS<BR>";
		print_r($serviceargs);
		echo "<BR>";
		*/

		$objt=array(
			"type" => OBJECTTYPE_SERVICE,
			"host_name" => $this->textboxes[1]->value,
			"use" => "xiwizard_generic_service",
			"service_description" => $this->textboxes[2]->value,
			"check_command" => 'check_smtp_delivery',
			"icon_image" => self::previewimage,
			"_xiwizard" => self::name,
			);

		// save data for later use in re-entrance
		$meta_arr=array();
		// We also doctor up the check_command and whatever else.
		foreach ( $this->textboxes as $textbox ) {
				$textbox->objs($meta_arr,$objt);
			}
		save_configwizard_object_meta(self::name,$this->textboxes[1]->value,
				'',$meta_arr);

		$objs=array();

		if(!host_exists($this->textboxes[1]->value)){
			$objs[]=array(
				"type" => OBJECTTYPE_HOST,
				"use" => "xiwizard_generic_host",
				"host_name" => $this->textboxes[1]->value,
				"address" => $this->textboxes[0]->value,
				"icon_image" => self::previewimage,
				"statusmap_image" => self::previewimage,
				"_xiwizard" => self::name,
				);
			}

		$objs[]=$objt;

		//echo "OBJECTS:<BR>";
		//print_r($objs);
		//exit();

		// return the object definitions to the wizard
		$this->outargs[CONFIGWIZARD_NAGIOS_OBJECTS]=$objs;

		}

	public function configwizard_func($mode="",
			$inargs=null,&$outargs,&$result){

		// Save away arguments as properties.
		$this->mode = $mode;
		$this->inargs = $inargs;
		$this->outargs =& $outargs;
		$this->result =& $result;

		// initialize return code and output
		$this->result=0;
		$output='';

		// initialize output args - pass back the same data we got
		$this->outargs[CONFIGWIZARD_PASSBACK_DATA]=$this->inargs;


		switch($this->mode){
		case CONFIGWIZARD_MODE_GETSTAGE1HTML:
			$this->getstaget1html($output);
			break;

		case CONFIGWIZARD_MODE_VALIDATESTAGE1DATA:
			$this->validatestage1data($output);
			break;

		case CONFIGWIZARD_MODE_GETSTAGE2HTML:
			$this->getstaget2html($output);
			break;

		case CONFIGWIZARD_MODE_VALIDATESTAGE2DATA:
			$this->validatestage2data($output);
			break;

		case CONFIGWIZARD_MODE_GETSTAGE3HTML:
			$this->getstaget3html($output);
			break;

		case CONFIGWIZARD_MODE_VALIDATESTAGE3DATA:
			$this->validatestage3data($output);
			break;

		case CONFIGWIZARD_MODE_GETFINALSTAGEHTML:
			$this->getfinalstagehtml($output);
			break;

		case CONFIGWIZARD_MODE_GETOBJECTS:
			$this->getobjects($output);
			break;

		default:
			break;			
		}
		
	return $output;
	}
}

/******************************************************
 * This last part should also be merged into NagiosXI *
 ******************************************************/
switch (CONFIGWIZARD_API_VERSION) {
case 2:
	function email_delivery_static_configwizard_func($mode="",
			$inargs=null,&$outargs,&$result) {
		return email_delivery_static_configwizard::configwizard_func($mode,
			$inargs,$outargs,$result);
		}

case 3:
	class email_delivery_static_configwizard {

		public static $obj;

		public static function configwizard_init(){
			self::$obj = new email_delivery_object_configwizard();
			$ret =& self::$obj->configwizard_init();

			// if(CONFIGWIZARD_API_VERSION===2)
				register_configwizard(email_delivery_object_configwizard::name,
					self::$obj->args);

			return $ret;
			}

		public static function configwizard_func($mode="",
				$inargs=null,&$outargs,&$result){
			return self::$obj->configwizard_func($mode,
				$inargs,$outargs,$result);
			}

		}

	// run the initialization function
	email_delivery_static_configwizard::configwizard_init();

	break;
case 4:
	$configwizards[] = new email_delivery_object_configwizard();
	break; }
?>
